<template>
	<div class="drawer_container">
		<div v-if="drawerType === 'grid'">
			<div class="drawer_title">画布背景设置</div>
			<div class="drawer_wrap">
				<Form label-position="left" :label-width="85">
					<FormItem label="是否显示网格" :label-width="100">
						<i-switch v-model="showGrid" @on-change="changeGrid" />
					</FormItem>
					<div v-show="showGrid">
						<FormItem label="网格类型">
							<RadioGroup v-model="grid.type" @on-change="changeGridType">
								<Radio v-for="item in gridTypeList" :label="item.value" :key="item.value">
									<span>{{item.label}}</span>
								</Radio>
							</RadioGroup>
						</FormItem>
						<FormItem label="网格大小">
							<Slider v-model="grid.size" :min="0" :max="30" @on-change="changeGrid"></Slider>
						</FormItem>
						<FormItem label="网格颜色">
							<ColorPicker v-model="grid.args.color" @on-change="changeGrid"/>
						</FormItem>
						<FormItem label="网格线宽度">
							<Slider v-model="grid.args.thickness" :min="0" :max="20" @on-change="changeGrid"></Slider>
						</FormItem>
						<FormItem label="数据集">
							<Select v-model="choose_dataset" style="width:200px">
								<Option v-for="item in datasetList" :value="item.value" :key="item.value">{{ item.label }}</Option>
							</Select>
						</FormItem>
						<FormItem label="学习轮次" style="width:200px">
							<InputNumber :max="10000000" :min="1" v-model="epoch" style="width:200px"></InputNumber>
						</FormItem>
						<FormItem label="学习率" style="width:200px">
							<InputNumber :max="1" :min="0" :step="0.000001" v-model="ir_ratio" style="width:200px"></InputNumber>
						</FormItem>

					</div>
				</Form>
			</div>
		</div>
		<div v-if="drawerType === 'node'">
			<div class="drawer_title">节点设置</div>
			<div class="drawer_wrap">
				<Form label-position="left" :label-width="100">
					<FormItem label="节点文本">
						<Input v-model="drawerNode.nodeText" @on-change="changeNodeText"></Input>
					</FormItem>
					<FormItem label="节点背景">
						<ColorPicker v-model="drawerNode.fill" @on-change="changeFill"/>
					</FormItem>
					<FormItem label="字体大小">
						<Slider v-model="drawerNode.fontSize" :min="10" :max="20" @on-change="changefontSize"></Slider>
					</FormItem>
					<FormItem label="字体颜色">
							<ColorPicker v-model="drawerNode.fontFill" @on-change="changeFontFill"/>
					</FormItem>
					<FormItem label="边框宽度">
						<Slider v-model="drawerNode.strokeWidth" :min="0" :max="10" @on-change="changeStrokeWidth"></Slider>
					</FormItem>
					<FormItem label="边框颜色">
						<ColorPicker v-model="drawerNode.stroke" @on-change="changeStroke"/>
					</FormItem>
					<template v-if="LayerType === 'conv_layer'">
						<FormItem label="输入通道数">
							<Input v-model="drawerNode.in_channels" @on-change="changeInchans"></Input>
						</FormItem>
						<FormItem label="输出通道数">
							<Input v-model="drawerNode.out_channels" @on-change="changeOutchans"></Input>
						</FormItem>
						<FormItem label="卷积核大小">
							<Input v-model="drawerNode.kernel_size" @on-change="changeKernelSize"></Input>
						</FormItem>
						<FormItem label="卷积核步长">
							<Input v-model="drawerNode.stride" @on-change="changeStride"></Input>
						</FormItem>
						<FormItem label="填充大小">
							<Input v-model="drawerNode.padding" @on-change="changePadding"></Input>
						</FormItem>
					</template>
					<template v-if="LayerType === 'pooling_layer'">
						<FormItem label="池化大小">
							<Input v-model="drawerNode.kernel_size" @on-change="changeKernelSize"></Input>
						</FormItem>
						<FormItem label="池化步长">
							<Input v-model="drawerNode.stride" @on-change="changeStride"></Input>
						</FormItem>
					</template>
					<template v-if="LayerType === 'activate_function'">
						<FormItem label="激活函数类型">
							<Input v-model="drawerNode.ActFunc" @on-change="changeActFunc"></Input>
						</FormItem>
					</template>
					<template v-if="LayerType === 'fc_layer'">
						<FormItem label="输入特征数">
							<Input v-model="drawerNode.in_features" @on-change="changeInfeat"></Input>
						</FormItem>
						<FormItem label="输出特征数">
							<Input v-model="drawerNode.out_features" @on-change="changeOutfeat"></Input>
						</FormItem>
					</template>

					<FormItem label="功能">
						<Button type="primary" icon="md-trending-up" @click="toTopZIndex">置顶</Button>
						<Button type="error" class="margin-left-10" icon="md-trash" @click="deleteNode">删除</Button>
					</FormItem>
				</Form>
			</div>
		</div>
		<div v-if="drawerType === 'edge'">
			<div class="drawer_title">线条设置</div>
			<div class="drawer_wrap">
				<Form label-position="left" :label-width="80">
					<FormItem label="线条文本">
						<Input v-model="drawerEdge.EdgeText" @on-change="changeEdgeText"></Input>
					</FormItem>
					<FormItem label="线条宽度">
						<Slider v-model="drawerEdge.edgeWidth" :min="1" :max="10" @on-change="changeEdgeWidth"></Slider>
					</FormItem>
					<FormItem label="线条颜色">
						<ColorPicker v-model="drawerEdge.edgeColor" @on-change="changeEdgeColor"/>
					</FormItem>
					<FormItem label="功能">
						<Button type="primary" icon="md-trending-up" @click="toTopZIndex">置顶</Button>
						<Button type="error" class="margin-left-10" icon="md-trash" @click="deleteNode">删除</Button>
					</FormItem>
				</Form>
			</div>
		</div>
	</div>
</template>

<script>
export default {
	name:'RightDrawer',
	data() {
		return {
			gridTypeList:[
				{
					label:'四边网格',
					value:'mesh'
				},
				{
					label:'点状网格',
					value:'dot'
				}
			],
			showGrid:true,
			drawerNode:{
				fill:'',
				nodeText:'',
				fontSize:null,
				fontFill:'',
				strokeWidth:null,
				stroke:'',
				in_channels: 1, //进通道数
				out_channels: 1,//出通道数
				kernel_size:3, //卷积核数
				stride:3, //卷积核每步移动的距离
				padding:0, //填充像素点框
				in_features:0,
				out_features:0,
				ActFunc:"relu"
			},
			drawerEdge:{
				EdgeText:'',
				edgeWidth:null,
				edgeColor:''
			},
			epoch:1,
			choose_dataset:"",
			ir_ratio:0.000004,
			datasetList:[
				{
					value: 'minst',
					label: 'minst'
				},
				{
					value: 'CIFAR-10',
					label: 'CIFAR-10'
				},
				{
					value: 'ImageNet-2M',
					label: 'ImageNet-2M'
				},
			]
			
		}
	},
	props:{
		LayerType: {
			type: String
		},
		drawerType: {
			type: String
		},
		selectCell:{
			type: String | Object
		},
		graph:{
			type: String | Object
		},
		grid:{
			type: Object
		}
	},
	created() {
			
	},
	mounted() {
	},
	watch:{
		selectCell: {
			handler(val) {
				if (val) {
					if (val.isNode()) { //节点
						this.drawerNode.fill = val.store.data.attrs.body.fill
						this.drawerNode.nodeText = val.store.data.attrs.label.text
						this.drawerNode.fontFill = val.store.data.attrs.label.fill
						this.drawerNode.fontSize = Number(val.store.data.attrs.label.fontSize)
						this.drawerNode.strokeWidth = Number(val.store.data.attrs.body.strokeWidth)
						this.drawerNode.stroke = val.store.data.attrs.body.stroke
						this.drawerNode.in_channels = val.store.data.attrs.data.in_channels
						this.drawerNode.out_channels = val.store.data.attrs.data.out_channels
						this.drawerNode.kernel_size = val.store.data.attrs.data.kernel_size
						this.drawerNode.padding = val.store.data.attrs.data.padding
						this.drawerNode.stride = val.store.data.attrs.data.stride
						this.drawerNode.in_features = val.store.data.attrs.data.in_features
						this.drawerNode.out_features = val.store.data.attrs.data.out_features
						this.drawerNode.ActFunc = val.store.data.attrs.data.ActFunc
					} else { //边
						this.drawerEdge.EdgeText = val.store.data.labels ? val.store.data.labels[0].text : ''
						this.drawerEdge.edgeWidth = Number(val.store.data.attrs.line.strokeWidth)
						this.drawerEdge.edgeColor = val.store.data.attrs.line.stroke
					}
				}
			},
			immediate: true,
			deep: false
		}
	},
	methods: {
		// 网格设置
		changeGrid () {
			this.showGrid ? this.graph.showGrid() : this.graph.hideGrid()
		},
		changeGridType (e) {
			this.grid.type = e
			this.changeGrid()
		},
		changeGrid () {
			this.graph.drawGrid({
				...this.grid
			})
		},
		// 节点设置
		changeStrokeWidth (val) {
			this.selectCell.attr('body/strokeWidth', val)
		},
		changefontSize (val) {
			this.selectCell.attr('label/fontSize',val)
		},
		changeNodeText () {
			this.selectCell.attr('label/text', this.drawerNode.nodeText)
		},
		changeStroke (val) {
			this.drawerNode.stroke = val
			this.selectCell.attr('body/stroke', this.drawerNode.stroke)
		},
		changeFontFill (val) {
			this.drawerNode.fontFill = val
			this.selectCell.attr('label/fill', this.drawerNode.fontFill)
		},
		changeFill (val) {
			this.drawerNode.fill = val
			this.selectCell.attr('body/fill', val)
		},
		// 边设置
		changeEdgeText () {
			console.log(this.drawerEdge.EdgeText);
			this.selectCell.setLabels( 
				[{attrs:{label:{text:this.drawerEdge.EdgeText}}}]
			)
		},
		changeEdgeWidth (val) {
			this.drawerEdge.edgeWidth = val
			this.selectCell.attr('line/strokeWidth', this.drawerEdge.edgeWidth)
		},
		changeEdgeColor (val) {
			this.drawerEdge.stroke = val
			this.selectCell.attr('line/stroke', this.drawerEdge.stroke)
		},
		changeInchans(){
			this.selectCell.attr("data/in_channels",this.drawerNode.in_channels)
		},
		changeOutchans(){
			this.selectCell.attr("data/out_channels",this.drawerNode.out_channels)			
		},
		changeKernelSize(){
			this.selectCell.attr("data/kernel_size",this.drawerNode.kernel_size)
		},
		changeStride(){
			this.selectCell.attr("data/stride",this.drawerNode.stride)
		},
		changePadding(){
			this.selectCell.attr("data/padding",this.drawerNode.padding)
		},
		changeInfeat(){
			this.selectCell.attr("data/in_features",this.drawerNode.in_features)
		},
		changeOutfeat(){
			this.selectCell.attr("data/out_features",this.drawerNode.out_features)
		},
		changeActFunc(){
			this.selectCell.attr("data/ActFunc",this.drawerNode.ActFunc)
		},
		// 置顶
		toTopZIndex () {
			this.selectCell.toFront()
		},
		// 删除
		deleteNode () {
			this.$emit('deleteNode')
		}
	}
}
</script>

<style lang="scss" scoped>
.drawer_container {
	max-width: 300px;
	min-width: 300px;
	.drawer_title {
		border-bottom: 1px solid #e8eaec;
		box-sizing: border-box;
		padding: 14px 16px;
		color: #333;
		font-size: 16px;
	}
	.drawer_wrap {
		box-sizing: border-box;
		padding: 20px 10px 20px 20px;
	}
}
</style>
